package com.sysu.admin;

import com.xiesx.fastboot.core.jpa.annotation.EnableJpaPlusDataSourceRepositories;
import org.springframework.boot.Banner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.autoconfigure.validation.ValidationAutoConfiguration;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;

import com.xiesx.fastboot.core.jpa.annotation.EnableJpaPlusRepositories;

import lombok.extern.slf4j.Slf4j;

/**
 * @title ZeduApplication
 * @description SpringBoot启动入口
 * @author XIE
 * @date 2020年1月6日下午2:06:58
 */
@Slf4j
@EnableJpaAuditing
@EnableCaching
@EnableJpaPlusRepositories
@SpringBootApplication(exclude = {ValidationAutoConfiguration.class})
public class MarkApplication extends SpringBootServletInitializer {

    public static void main(String[] args) {
        SpringApplication app = new SpringApplication(MarkApplication.class);
        app.setBannerMode(Banner.Mode.CONSOLE);
        app.run(args);
        log.info("Started ZeduApplication 启动成功");
    }

}
