package com.sysu.admin.api.crop;

import com.sysu.admin.api.valid.ApiReqValid;
import com.sysu.admin.controller.crop.images.CropImage;
import lombok.Data;
import lombok.experimental.FieldNameConstants;

import javax.persistence.Column;
import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
@FieldNameConstants(innerTypeName = "FIELDS")
public class CropVo {
    @NotNull(message = "id为空！")
    private Long id;
    private Integer status;
    private Double[] point;
    private Integer meter;
    @NotNull(message = "作物类型为空！")
    private Integer cropType;
    @NotNull(message = "生长周期为空！")
    private Integer growingPeriod;
    private Integer yield;
    @NotNull(message = "远景图片为空！")
    private CropImage fay;
    @NotNull(message = "中景图片为空！")
    private CropImage center;
    @NotNull(message = "近景图片为空！")
    private CropImage near;
    @NotNull(message = "采集经度为空！")
    private Double pickLongitude;
    @NotNull(message = "采集纬度为空！")
    private Double pickLatitude;
    @NotNull(message = "采集时间为空！")
    private Date pickDate;
    private String desc;
    private String name;
    private String address;
    private Integer confirm;

    @NotNull(message = "token为空！", groups = {ApiReqValid.TokenCheckValid.class})
    private String token;

}
