package com.sysu.admin.support.tree;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Builder;
import lombok.Data;

import java.util.List;

/**
 * @title Tree
 * @description
 * @author XIE
 * @date 2020年4月24日下午10:01:15
 */
@Data
@Builder
public class Tree {

    // 节点唯一索引
    @JSONField(ordinal = 1)
    public String id;

    // 节点标题
    @JSONField(ordinal = 2)
    public String title;

    // 子节点
    @JSONField(ordinal = 3)
    public List<Tree> children;

    // 节点是否初始展开
    @JSONField(ordinal = 4)
    public Boolean spread;

    // 初始为选中状态
    @JSONField(ordinal = 5)
    public Boolean checked;

    // 初始为禁用状态
    @JSONField(ordinal = 6)
    public Boolean disabled;

    // 级别
    @JSONField(ordinal = 7)
    private Integer grade;
}
