<%@ page contentType="text/html;charset=UTF-8" language="java" trimDirectiveWhitespaces="true"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://shiro.apache.org/tags" prefix="shiro"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<c:set var="base" value="${pageContext.request.contextPath}" />
<shiro:notAuthenticated>
	<%
	    response.sendRedirect("/login");
	%>
</shiro:notAuthenticated>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<title>重庆市农业一张图</title>
<meta name="renderer" content="webkit">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<!--UC强制全屏-->
<meta name="full-screen" content="yes">
<!--UC应用模式-->
<meta name="browsermode" content="application">
<!--QQ强制全屏-->
<meta name="x5-fullscreen" content="true">
<!--QQ应用模式-->
<meta name="x5-page-mode" content="app">
<!-- 强制移动设备以app模式打开页面(即在移动设备下全屏，仅支持部分浏览器) -->
<meta name="apple-mobile-web-app-capable" content="yes">
<meta name="apple-touch-fullscreen" content="yes">
<meta name="apple-mobile-web-app-status-bar-style" content="black">
<meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
<link href="${base}/static/js/layuiadmin/layuiadmin/layui/css/layui.css" rel="stylesheet" />
<link href="${base}/static/js/layuiadmin/layuiadmin/style/admin.css" rel="stylesheet">
<script src="https://cdn.bootcss.com/jquery/2.2.1/jquery.min.js"></script>
</head>
<body class="layui-layout-body">

	<div id="LAY_app">
		<div class="layui-layout layui-layout-admin">

			<!-- 头部区域 -->
			<div class="layui-header">
				<ul class="layui-nav layui-layout-left">
					<li class="layui-nav-item layadmin-flexible" lay-unselect><a href="javascript:;" layadmin-event="flexible" title="<spring:message code="admin.side_stretch"/>"> <i class="layui-icon layui-icon-shrink-right"
							id="LAY_app_flexible"></i>
					</a></li>
<%--					<li class="layui-nav-item layui-hide-xs" lay-unselect><a href="${base}/mark/index" target="_blank" title="mark"> <i class="layui-icon layui-icon-layer"></i>--%>
<%--					</a></li>--%>
					<li class="layui-nav-item" lay-unselect><a href="javascript:;" layadmin-event="refresh" title="<spring:message code="refresh"/>"> <i class="layui-icon layui-icon-refresh-3"></i>
					</a></li>
				</ul>
				<ul class="layui-nav layui-layout-right" lay-filter="layadmin-layout-right">
					<!-- <li class="layui-nav-item" lay-unselect><a lay-href="/js/layuiadmin/views/app/message/index.html" layadmin-event="message" lay-text="消息中心"> <i class="layui-icon layui-icon-notice"></i> <span
							class="layui-badge-dot"></span>
					</a></li> -->
					<li class="layui-nav-item" lay-unselect><a href="javascript:;"> <shiro:principal property="nickname" />
					</a>
						<dl class="layui-nav-child">
								<!-- <dd>
									<a lay-href="set/user/info.html">基本资料</a>
								</dd>
								<hr>-->
								<dd>
									<a lay-href="/admin/password"><spring:message code="admin.change_password"/></a>
								</dd>
								<dd layadmin-event="logout">
									<a><spring:message code="admin.logout"/></a>
								</dd>
							<shiro:guest>
								<dd>
									<a href="/login"><spring:message code="login"/></a>
								</dd>
							</shiro:guest>
						</dl></li>
					<li class="layui-nav-item layui-hide-xs" lay-unselect><a href="javascript:;" layadmin-event="more"> <i class="layui-icon layui-icon-more-vertical"></i>
					</a></li>
					<li class="layui-nav-item layui-show-xs-inline-block layui-hide-sm" lay-unselect><a href="javascript:;" layadmin-event="more"> <i class="layui-icon layui-icon-more-vertical"></i>
					</a></li>
				</ul>
			</div>

			<!-- 侧边菜单 -->
			<div class="layui-side layui-side-menu">

				<div class="layui-side-scroll">
					<div class="layui-logo" lay-href="${base}/console">
						<span>后台管理</span>
					</div>

					<ul class="layui-nav layui-nav-tree" lay-shrink="all" id="LAY-system-side-menu" lay-filter="layadmin-system-side-menu" />
				</div>
			</div>

			<!-- 页面标签 -->
			<div class="layadmin-pagetabs" id="LAY_app_tabs">
				<div class="layui-icon layadmin-tabs-control layui-icon-prev" layadmin-event="leftPage"></div>
				<div class="layui-icon layadmin-tabs-control layui-icon-next" layadmin-event="rightPage"></div>
				<div class="layui-icon layadmin-tabs-control layui-icon-down">
					<ul class="layui-nav layadmin-tabs-select" lay-filter="layadmin-pagetabs-nav">
						<li class="layui-nav-item" lay-unselect><a href="javascript:;"></a>
							<dl class="layui-nav-child layui-anim-fadein">
								<dd layadmin-event="closeThisTabs">
									<a href="javascript:;"><spring:message code="admin.close_current"/></a>
								</dd>
								<dd layadmin-event="closeOtherTabs">
									<a href="javascript:;"><spring:message code="admin.close_others"/></a>
								</dd>
								<dd layadmin-event="closeAllTabs">
									<a href="javascript:;"><spring:message code="admin.close_all"/></a>
								</dd>
							</dl></li>
					</ul>
				</div>
				<div class="layui-tab" lay-unauto lay-allowClose="true" lay-filter="layadmin-layout-tabs">
					<ul class="layui-tab-title" id="LAY_app_tabsheader">
						<li lay-id="${base}/console" class="layui-this"><i class="layui-icon layui-icon-home"></i></li>
					</ul>
				</div>
			</div>

			<!-- 主体内容 -->
			<div class="layui-body" id="LAY_app_body">
				<div class="layadmin-tabsbody-item layui-show">
					<iframe src="${base}/console" frameborder="0" class="layadmin-iframe"></iframe>
				</div>
			</div>

			<!-- 辅助元素，一般用于移动设备下遮罩 -->
			<div class="layadmin-body-shade" layadmin-event="shade"></div>
		</div>
	</div>
	<script src="${base}/static/js/layuiadmin/layuiadmin/layui/layui.js"></script>
	<script>
		layui.config({
			base : '${base}/static/js/layuiadmin/layuiadmin/' //静态资源所在路径
		}).extend({
			index : 'lib/index' //主入口模块
		}).use([ 'index', 'nav' ], function() {
			// 操作对象
			var $ = layui.jquery, layer = layui.layer, element = layui.element, nav = layui.nav;
			// 主体菜单生成
			//nav.main('${base}/static/js/data/menu_main.js', 'layadmin-system-side-menu', false);
			nav.main('${base}/admin/navigation', 'layadmin-system-side-menu', false);
		});
	</script>
</body>
</html>